package com.emato.cuspay.util;

import com.emato.cuspay.support.msg.resp.ResponseMessage;
import com.emato.cuspay.support.msg.resp.ResponseStatus;
import org.apache.commons.lang3.StringUtils;

import java.util.Map;

/**
 * @author zx
 * @version 1.0
 * 2018-05-15 16:48
 */
public abstract class Validator {
    /**
     * 非空校验
     *
     * @param beVerified 要验证的字段 <code>{"字段名","错误消息"}</code>
     * @param valideDate       验证数据
     * @return
     */
    public static ResponseMessage isEmpty(Map<String, Object> beVerified, Map<String, Object> valideDate) {


        /**
         * 验证数据为空
         */
        if (valideDate == null) {
            return new ResponseMessage.Builder()
                        .setCode(ResponseStatus.ERROR.code)
                        .setMsg("验证数据为空")
                        .build();
        }

        /**
         * 没有要验证的
         */
        if (beVerified == null) {
            return new ResponseMessage.Builder()
                    .setCode(ResponseStatus.ERROR.code)
                    .setMsg("没有要验证的数据")
                    .build();
        }

        for (String key : beVerified.keySet()) {
            //验证数据没有要验证的字段, 或有要验证的字段,但字段为空
            if (!valideDate.containsKey(key) ||
                    (valideDate.containsKey(key) && StringUtils.isBlank(String.valueOf(valideDate.get(key)))) ||
                    String.valueOf(valideDate.get(key)).equals("null")) {
                return  ResponseMessage.builder(ResponseStatus.ERROR.code, beVerified.get(key)+"为空").build();
            }
        }
        return new ResponseMessage.Builder()
                    .setCode(ResponseStatus.SUCCESS.code)
                    .build();
    }
}
